package dev.shadowsoffire.apotheosis.adventure.commands;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.suggestion.SuggestionProvider;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.Arrays;
import java.util.concurrent.CompletableFuture;
import java.util.function.Predicate;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.commands.SharedSuggestionProvider;
import net.minecraft.commands.arguments.ResourceLocationArgument;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.registries.ForgeRegistries;

public class GemCommand {
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_OP;
  
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_ATTRIB;
  
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_GEM;
  
  static {
    SUGGEST_OP = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(Arrays.<AttributeModifier.Operation>stream(AttributeModifier.Operation.values()).map(Enum::name), builder));
    SUGGEST_ATTRIB = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(ForgeRegistries.ATTRIBUTES.getKeys().stream().map(ResourceLocation::toString), builder));
    SUGGEST_GEM = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(GemRegistry.INSTANCE.getKeys().stream().map(ResourceLocation::toString), builder));
  }
  
  public static void register(LiteralArgumentBuilder<CommandSourceStack> root) {
    root.then(((LiteralArgumentBuilder)((LiteralArgumentBuilder)Commands.m_82127_("gem").requires(c -> c.m_6761_(2))).then(Commands.m_82127_("fromPreset").then(Commands.m_82129_("gem", (ArgumentType)ResourceLocationArgument.m_106984_()).suggests(SUGGEST_GEM).executes(c -> {
                Gem gem = (Gem)GemRegistry.INSTANCE.getValue(ResourceLocationArgument.m_107011_(c, "gem"));
                ServerPlayer serverPlayer = ((CommandSourceStack)c.getSource()).m_81375_();
                ItemStack stack = GemRegistry.createGemStack(gem, LootRarity.random(((Player)serverPlayer).f_19796_, serverPlayer.m_36336_()));
                serverPlayer.m_36356_(stack);
                return 0;
              })))).then(Commands.m_82127_("random").executes(c -> {
              ServerPlayer serverPlayer = ((CommandSourceStack)c.getSource()).m_81375_();
              ItemStack gem = GemRegistry.createRandomGemStack(((Player)serverPlayer).f_19796_, ((CommandSourceStack)c.getSource()).m_81372_(), serverPlayer.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches(serverPlayer.m_9236_()), GameStagesCompat.IStaged.matches((Player)serverPlayer) });
              serverPlayer.m_36356_(gem);
              return 0;
            })));
  }
}
